/**
 * \file
 *
 * \brief Empty user application template
 *
 */

/**
 * \mainpage User Application template doxygen documentation
 *
 * \par Empty user application template
 *
 * This is a bare minimum user application template.
 *
 * For documentation of the board, go \ref group_common_boards "here" for a link
 * to the board-specific documentation.
 *
 * \par Content
 *
 * -# Include the ASF header files (through asf.h)
 * -# Minimal main function that starts with a call to board_init()
 * -# Basic usage of on-board LED and button
 * -# "Insert application code here" comment
 *
 */

/*
 * Include header files for all drivers that have been imported from
 * Atmel Software Framework (ASF).
 */
/*
 * Support and FAQ: visit <a href="http://www.atmel.com/design-support/">Atmel Support</a>
 */
#include <asf.h>

int main (void)
{
	char DisplayString[] = "This is an OLED test.";
	char DisplayChar[2];
	uint8_t DisplayString_Length = 21;
	uint8_t n;
	
	//clock configuration and initialization
	sysclk_init();
	
	/*Disable the watchdog timer and configure/initialize
	port pins connected to various components incorporated 
	into the SAM4S Xplained development platform, e.g., the 
	NAND flash, the OLED interface, the LEDs, the SW0 pushbutton.*/  
	board_init();

	//initialize SPI and the OLED controller
	ssd1306_init();
	
	/*The second character in this two-character array must be zero
	so that the ssd1306_write_text() function correctly interprets the
	array as a one-character string.*/
	DisplayChar[1] = 0;
	
	while (1)
	{
		//clear the OLED screen, then set the cursor to the top-left character position
		ssd1306_clear();
		ssd1306_set_page_address(0);
		ssd1306_set_column_address(0);
		
		for (n = 0; n < DisplayString_Length; n++)
		{
			/*Copy the current character of DisplayString
			to the one-character array DisplayChar.*/
			DisplayChar[0] = DisplayString[n];
			
			//display the single character
			ssd1306_write_text(DisplayChar);
			
			//the ASF includes handy delay functions
			delay_ms(400);
		}
	}
}